SystemOrganization addCategory: #'SCouchDB-Application-Tests-Functional'!
SystemOrganization addCategory: #'SCouchDB-Application-Tests-Functional-Albums'!

SCouchDBApp subclass: #Albums
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Tests-Functional-Albums'!

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/14/2013 11:00'!
initEvently

self initEventlyFooters.
self initEventlyAlbumView.
self initEventlyAlbumDelete.
self initEventlyLoginDialog.
self initEventlyAlbumEdit.
self initEventlyAlbumAdd. 
self initEventlyAlbumSearch! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 04:44'!
initEventlyAlbumAdd

(self evently at:'albumAdd' )
		onEvent:'addCancel' do:
		'function( event ){
	   		$.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
    		}'; 
		onEvent:'addConfirm' do:
		'function(e){
		var document = {};
            document.artist = $("input#addArtistField").val();
            document.title = $("input#addTitleField").val();
            document.description = $("textarea#addDescriptionField").val();
            document.creation_date = ( new Date() ).getTime();
            $.albums.saveDocument( document, {
                    success: function() {
                           $.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
                    },
                    error: function( status, error, reason ) {
                        alert( "Cannot save new document.\n" + status + ", " + reason + ", " + error );
                    }
              });
		}'.! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 00:10'!
initEventlyAlbumDelete

(self evently at:'albumDelete' )
		onEvent:'deleteCancel' do:'function( event ){
       		var docId = $("#deleteFooter").data("identity");
        		$.mobile.changePage( "/albums/_design/albums/_show/album/" + docId, "slide", true, true );
        		return false;
    		}'; 
		onEvent:'deleteConfirm' do:'function( event ){
	        var docId = $("#deleteFooter").data("identity");
	        // First open doc based on ID in order to get the  latest _revision.
	        $db.openDoc( docId, {
	            success: function( document ){
	                // Then use the opened doc as reference to remove.
	                $.albums.deleteDocument( document, {
	                    success:function(){
	                        $.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
	                    },
	             	   error:function( status, error, reason ){
	                        alert( "Could not remove document with id: " + docId + "\n" + reason );
	                    }
	                });
	            },
	            error:function(){
	                alert( "Could not find document with id: " + docId );
	            }
	        });
	        return false;
	    }'! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/10/2012 18:17'!
initEventlyAlbumEdit

(self evently at:'albumEdit' )
		onEvent:'editCancel' do:
		'function( event ){
        		var docId = $("#albumEditPage").data("identity");
        		$.mobile.changePage( "/albums/_design/albums/_show/album/" + docId, "slide", true, true );
    		}'; 
		onEvent:'editConfirm' do:
		'function(e){
			var currentAlbum= $$(this).currentAlbum;
			currentAlbum.artist = $("input#artistField").val();
			currentAlbum.title = $("input#titleField").val();
			currentAlbum.description = $("textarea#descriptionField").val();

			$.albums.saveDocument( currentAlbum, {	
				success: function( response )  {
					$.mobile.changePage( "/albums/_design/albums/_show/album/" + currentAlbum._id,"flip", true, true );
				},
				error: function( status, error, reason ) {
					alert( "Cannot save document: " + document._id + "\n" + reason );
				}
			});
		}';
		onEvent:'_init' 
		data:'function(e){
			var docId = $("#albumEditPage").data("identity");
			var currentAlbum;
			$db.openDoc( docId, {
					success: function( document ) {
						currentAlbum=document;
						
					},
					error: function() {
						alert( "Cannot open document: " + docId );
					}
				},
				{async:false});
			$$(this).currentAlbum = currentAlbum;			
			return  $$(this).currentAlbum;
		}'
		mustache:
		'<form id="albumform" action="#" method="get" >
  			<div data-role="fieldcontain"> 
	        	<label for="artist">Artist:</label> 
	   	    	<input id="artistField" name="artist" type="text" value="{{artist}}" />
			</div>
			<div data-role="fieldcontain"> 
	        	<label for="title">Title:</label> 
	   	    	<input id="titleField" name="title" type="text" value="{{title}}" />
			</div>
			<div data-role="fieldcontain"> 
				<label for="description">Description:</label> 
				<textarea id="descriptionField" name="description" cols="40" rows="8">{{description}}</textarea> 
			</div>
		</form>'! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/14/2013 10:35'!
initEventlyAlbumSearch

(self evently at:'albumSearch' )
		onEvent:'searchCancel' do:
		'function( event ){
	   		$.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
    		}'; 
		onEvent:'searchConfirm' do:
		'function(e){
		var searchFieldContent = '''';
            searchFieldContent = $("input#searchField").val();
            $.mobile.changePage( "/albums/_design/albums/_list/albumSearch/albums?fieldContent=" + searchFieldContent, "slide", true, true );
		}'.! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 05:18'!
initEventlyAlbumView

(self evently at:'albumView') 
		onEvent:'albumDelete' do:'function(e,data){
		// Access document id from data-identity.
		var docId = $("#albumcontent").data("identity");
		// Change page.
		$.mobile.changePage( "/albums/_design/albums/_show/album-delete/" + docId, "slideup", false, false );
		}'; 
		onEvent:'albumEdit' do:
		'function(e,data){
		// Access document id from data-identity.
		var docId = $("#albumcontent").data("identity");
		// Change page.
		$.mobile.changePage( "/albums/_design/albums/_show/album-edit/" + docId, "flip", false, true )
		}';
		onEvent:'albumLet' do:	
			'function(e,data){
			var docId = $("#albumcontent").data("identity");
			// Change page.
			$.albums.letDocument(docId, {
				"success": function(){$.mobile.changePage( "/albums/_design/albums/_show/album-users/" + docId, "flip", false, true );}
			});
		}' ! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/14/2013 10:47'!
initEventlyFooters

(self evently at:'albumFooter' onEvent:'_init')
	selector: '#deleteButton' 
	onClick:'function(){
			$(this).trigger(''albumDelete'');
			}';
	selector: '#editButton' 
	onClick:'function(){
			$(this).trigger(''albumEdit'');
			}';
	selector:'#letButton' 
	onClick:'function(){
			$(this).trigger(''albumLet'');
			}'. 
			
(self evently at:'deleteFooter' onEvent:'_init')
	selector: '#dialogCloseButton' 
	onClick:'function(){
			$(this).trigger(''deleteCancel'');
			}';	
	selector: '#deleteCancelButton' 
	onClick: 'function(){
			$(this).trigger(''deleteCancel'');
			}';
	selector: '#deleteConfirmButton' 
	onClick:'function(){
			$(this).trigger(''deleteConfirm'');
			}'. 



(self evently at:'editFooter' onEvent:'_init')
	selector: '#editCancelButton' 
	onClick:'function(){
			$(this).trigger(''editCancel'');
			}';	
	selector: '#editConfirmButton' 
	onClick:'function(){
			$(this).trigger(''editConfirm'');
			}'. 
			
		
(self evently at:'addFooter' onEvent:'_init')
	selector: '#addCancelButton' 
	onClick:'function(){
			$(this).trigger(''addCancel'');
			}';	
	selector: '#addConfirmButton' 
	onClick:'function(){
			$(this).trigger(''addConfirm'');
			}'. 
			
(self evently at:'searchFooter' onEvent:'_init')
	selector: '#searchCancelButton' 
	onClick:'function(){
			$(this).trigger(''searchCancel'');
			}';	
	selector: '#searchConfirmButton' 
	onClick:'function(){
			$(this).trigger(''searchConfirm'');
			}'. 
			
(self evently at:'loginCtrl' onEvent:'_init')
	selector: '#dialogCloseButton' 
	onClick:'function(){
			$(this).trigger(''loginCancel'');
			}';	
	selector: '#loginConfirmButton' 
	onClick:'function(){
			$(this).trigger(''loginConfirm'');
			}'. ! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 04:53'!
initEventlyLoginDialog

(self evently at:'loginDialog' )
		onEvent:'loginCancel' do: 'function (e){$("#loginDialog").dialog(''close'');}';
		onEvent:'loginConfirm' do:
		'function(e,form){
			var username = $( "#username" ).attr(''value'');
  			var password = $( "#password" ).attr(''value'');
			//var uievent = ( ops.state == 0 ) ? "login" : "signup";
			$.albums.logIn(username,password);
			$(''#loginDialog'').dialog(''close'');
		}'! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/8/2012 20:19'!
initFilters
self addFilterAt:'mine'	
	put:
	[:doc :req|
		((doc user)= (req userCtx name)) 
	].
! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 19:47'!
initLists
self addListAt:'albumIndex' put:
[:head :req|	
		
self provides:'html' with:[:aHead :aReq|
	|doc stash albums template| 
	albums:=OrderedCollection new.
	[(doc:=self getRow ) isNil] whileFalse:[
		albums add: doc value.
		].

	template:=self templates at:'albumindex'.
	stash :=JsonObject fromAssociations: {
		'albums'->(albums asArray).
	}.
	self send: (Mustache toHtml:template view:stash partials: (self partials)).
	]
].


self addListAt:'albumSearch' put:
[:head :req|	
		
self provides:'html' with:[ :aHead :aReq|
	|doc stash albums template searchResults| 

	albums:=OrderedCollection new.

	searchResults:=(self indexerAt:'album-index') findPhrase: (aReq query at:'fieldContent')  minTarget: 0.8.

	[(doc:=self getRow ) isNil] whileFalse:[
		searchResults do:[:anAsociation|
		doc key = anAsociation key ifTrue:[albums add: doc value]
		] 
	].

	template:=self templates at:'albumindex'.
	stash :=JsonObject fromAssociations: {
		'albums'->(albums asArray).
	}.
	self send: (Mustache toHtml:template view:stash partials: (self partials)).
	]
]! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/17/2013 08:42'!
initShows
self addShowAt: 'album-login' put: [:aDoc :req|
	|template|

	template:=self templates at:'albumlogin'.
	Mustache toHtml:template view:aDoc partials: (self partials).		
	].

self addShowAt: 'album' put: [:aDoc :req|
	|stash template|
	template:=self templates at:'album'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'user'-> (aDoc at:'user').
		'document' -> (aDoc at:'_id')
	}.
	Mustache toHtml:template view:stash partials: (self partials).		
	].

self addShowAt: 'album-delete' put: 
[:aDoc :req|
	|stash template|
	template:=self templates at:'albumdelete'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'document' -> (aDoc at:'_id')
	}.
	Mustache toHtml:template view:stash partials: (self partials).		
	].


self addShowAt: 'album-edit' put: [:aDoc :req|
	|stash template|
	template:=self templates at:'albumedit'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'document' -> (aDoc at:'_id')
	}.
	Mustache toHtml:template view:stash partials: (self partials).		
	].

self addShowAt: 'album-users' put: [:aDoc :req|
	| template adminUsers userCollection stash|
	
	adminUsers:=((req at:'secObj') at:'admins') at:'names'.
	userCollection:=OrderedCollection new.
	adminUsers do:[:anUserName|
		userCollection add: (
			JsonObject fromAssociations: {'userName'->anUserName})
		].

	
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'document' -> (aDoc at:'_id').
		'loans'->(aDoc at:'loans').
		'admins'->(userCollection asArray)
	}.
	template:=self templates at:'albumusers'.

	Mustache toHtml:template view:stash partials: self partials.		
	].

self addShowAt: 'album-add' put: 
[:aDoc :req|
	|stash template|
	template:=self templates at:'albumadd'.
	Mustache toHtml:template view:stash partials: (self partials).		
	].


"
Depends on ObjectIndexer project
self addShowAt: 'album-search' put: 
[:aDoc :req|
	|stash template|
	template:=self templates at:'albumsearch'.
	Mustache toHtml:template view:stash partials: (self partials).		
	]."! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/21/2012 16:29'!
initUpdateHandler
self addUpdateHandlerAt: 'setNewUser' put:[:aDoc :req|
	|template stash loans|
	
	loans:=aDoc at:'loans'.
	loans ifNil:[loans:=OrderedCollection new]
		  ifNotNil:[loans:=OrderedCollection newFrom:loans].
	loans add:(JsonObject fromAssociations:{
							'user' -> ( req query newuser).
							'date' -> (DateAndTime now asString).
							}).
	aDoc at:'loans'  put:loans.
	template:=self templates at:'album'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'user' -> (aDoc at:'user').
		'document' -> (aDoc at:'_id').
	}.
	
	Array with:aDoc with:(Mustache toHtml:template view:stash partials: (self partials))
	].! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/12/2013 10:41'!
initValidator


self validateDocUpdate: [:newDoc :savedDoc :userContext|
| isDeletingWithoutPermission isUpdatingWithoutPermission isAlbumUser|
	isDeletingWithoutPermission:=false.
	isUpdatingWithoutPermission:=false.
	isAlbumUser:=(self isAdmin or:[ self userIs:'albums-user']).

	(userContext at:'name' ) 
	ifNil:[ ((UnauthorizedException new) messageText:'You need to be logged in order to do that.') signal]
	ifNotNil:[
		(isAlbumUser) ifFalse:[((ForbiddenException new) messageText: 'You do not have proper access to edit this document.') signal]
		].
	isDeletingWithoutPermission:=((newDoc at:'_deleted') notNil) and:[ (savedDoc user = userContext name) not].
	isUpdatingWithoutPermission:=(newDoc user = userContext name) not or:[
		savedDoc 
			ifNil:[false] 
			ifNotNil:[
				(newDoc user = savedDoc user) not.
			]].

	((self isAdmin not) and:[isDeletingWithoutPermission] ) 
	ifTrue:[
		
		((ForbiddenException new ) messageText:'Only the creator of this document has permission to delete') signal
	] ifFalse:[
		((self isAdmin  not) and:[isUpdatingWithoutPermission and:[(newDoc at:'_deleted') isNil ]] )
		 ifTrue:[
				((ForbiddenException new) messageText: 'Only the creator of this document has permission to update') signal
				] 
		ifFalse:[
				((newDoc at:'_deleted') = true) 
				ifFalse:[	self required:'user']
			]	
	]
]
! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 19:45'!
initViews.
self addViewAt:'albums'	
	put:
	[:doc|
		self emit: doc key:(doc at:'creation_date')
	].

"self addViewAt:'indexe'	
	put:
	[:doc|
		(self indexerAt:'album-index') indexeMessages:( doc keys) by:#id from:doc. 

	]."

	

self addViewAt:'recent-items'	
	put:
	[:doc|
		self emit: (doc at:'creation_date') key:(doc at:'creation_date')
	]
	reduce:'sum'.! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 19:15'!
initialize
super initialize.
self appName: 'albums'.
self language: 'smalltalk'.
self initViews.
self initShows.
self initLists.
self initEvently.
self initValidator.
self initUpdateHandler.
self initFilters.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\albums\attachments\'.
self importAllTemplatesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\albums\templates\'.
self connectTo:'localhost' port:5984 userName:'admin' password:'admin'.
self upload.


! !

SCouchDBApp subclass: #HelloViewServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Tests-Functional'!

!HelloViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/14/2012 13:16'!
initEvently
self addEvently: EventlyAccount new. 
! !

!HelloViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 20:16'!
initViews
self addViewAt:'recent-items'	
	put:
	[:doc|
		((doc at:'type')='users') ifTrue:[
			self emit:doc key:(doc at:'_id')
		]
	].! !

!HelloViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 19:15'!
initialize
super initialize.
self initViews.
self initEvently.

self importVendorFilesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\hello\vendor\'.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\hello\attachments\'.
self importAllTemplatesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\hello\templates\'.
self connectTo:'localhost' port:5984 userName:'admin' password:'admin'.
self upload.
! !

SCouchDBApp subclass: #SCouchAppTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Tests-Functional'!

!SCouchAppTest class methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/28/2012 11:02'!
test
|aDoc db adaptor docArray docs |
self halt.

docs:= Array 
		with:(JsonObject fromAssociations:{	'artist'->'Thin Lizzy' .
														'title'->'Fighting'.
														'description'->'Bona-fide Rock classic'   											
											})					
		with:(JsonObject fromAssociations:   { 	'artist'->'David Bowie' .
														'title'->'Honky Dory'.
														'description'->'Doesn''t get much better than this'  
											}) .


adaptor:=SCouchDBAdaptor new 
	host: '127.0.0.1' 
	port: 5984 
	userName:'admin' 
	password:'95t5boru'.
db:= adaptor ensureDatabase: 'albums'.


docs do:[:d|
	db documentPut: d.
	]



"db deleteDocument: '1234556789A' revision:'1-67cb06c9c5c2ebd05c16fdd4a8b77528'.

docArray Nothing more expected ->:=db documentRevsInfoAt: '1234556789A'.
Transcript show: docArray asString.
Transcript show: adaptor users asString.
Transcript show: adaptor uuids asString.

docArray do:[:aDoc|
	Transcript show: aDoc asString.
]   "! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/8/2012 09:55'!
initFilters
self addFilterAt:'mine'	
	put:
	[:doc :req|
		((doc owner)= (req userCtx name)) 
		ifTrue:[true]
		ifFalse:[false]
	].

! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/3/2013 13:19'!
initLists
self addListAt:'argumentList' put:
[:head :req|	
self provides:'html' with:[:aHead :aReq|
	|doc|
	[(doc:=self getRow ) isNil] whileFalse:[
		|val|
		val:=doc value.
		"Only tags with static content, do not include callback,etc "
		self sendOnCanvas:[:html|
			html heading level:2;with: (val aTag).
			html paragraph: (val aDescription).
			].
		]
	]
]! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/17/2012 17:22'!
initShows
self addShowAt:'helloWorld' put:
[:aDoc :req|
	self sendOnCanvas:[:html|
			html html:'
			<head>
				<title>CouchDB test</title>
				<meta http-equiv="Content-type" content="text/html; chanset=utf-8"/>
				<script src= "/_utils/script/json2.js"></script>
				<script src= "/_utils/script/sha1.js"></script>
				<script src= "/_utils/script/jquery.js?1.4.2"></script>
				<script src= "/_utils/script/jquery.couch.js?0.11.0"></script>
				<script src= "/_utils/script/jquery.dialog.js?0.11.0"></script>
			</head>'.
			html render: (JQSCouchDBTest new)
			].
	].


self addShowAt:'redirection' put:
[:aDoc :req|	
self redirectTo:'/_utils'
]! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/9/2012 20:02'!
initUpdates
self addUpdateHandlerAt:'argumentsToPepe'	
	put:
	[:doc :req|
		(doc owner) 
		ifNil:[Array with:nil with:' No hay na PEPE!!']
		ifNotNil:[
			doc owner:'pepe'.
			Array with:doc with:' To pa PEPE!!'].
		
		
	].

! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/16/2012 16:10'!
initValidator
self validateDocUpdate:
	[:newDoc :savedDoc :userContext|
		self field:'owner' shouldBe:userContext name.
		self assert:[newDoc includesKey:'_id'].		
	].

! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/6/2012 09:53'!
initViews
self addViewAt:'arguments'	
	put:
	[:doc|
		((doc at:'type')='argument') ifTrue:[
			self emit:doc key:(doc at:'aTag')
		]
	].


self addViewAt:'decisionsEdit'	
	put:
	[:doc |
	"view for decisions edition template"
		((doc at:'type')='decision') ifTrue:[
 	   		self emit:doc key: (doc at:'_id')
 	 	] 
	].


self addViewAt:'decisions'	
	put:[:doc| 
	|e|

	  ((doc  at:'type') ='decision') ifTrue:[
		e:=JsonObject new.
		e type:(doc at:'type');
		  description:(doc at:'description');
		  timesEvaluated:(doc at:'timesEvaluated').
		self emit: e key: (doc at:'_id').
	  ].
	"view for decisions list in the portal template"
].
self addViewAt:'dictionary'	
	put:[:doc| 
	((doc at:'type')='translation') ifTrue:[
		self emit:(doc at:'type') key:(Array with:(doc at:'language') with:(doc at:'of') with:(doc at:'text'))]
			]! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 19:16'!
initialize
super initialize.

self language:'smalltalk'.
self initLists.
self initShows.
self initViews.
self initFilters.
self initUpdates.
self initValidator.
"TODO: multipart does not work yet"
self halt.
self includeDocs:true.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\attachments\'.
self importAllTemplatesFrom: 'D:\smalltalk\SCouchViewServer\templates\'.
self connectTo:'localhost' port:5984 userName:'admin' password:'admin'.
self upload.
! !
